#!/usr/bin/python3
# -*- coding: utf-8 -*-

import sys
# reload(sys)
# sys.setdefaultencoding('utf8')
from PyQt5.QtGui import *
from PyQt5.QtCore import *
from PyQt5.QtWidgets import QListWidget, QFrame

from mainui.systembutton import CleanButton
from mainui.button import *

import gettext
gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

class BottomWidget(QWidget):

    tristate_status = 2
    ordinary_or_important = False

    click_item=False

    def __init__(self, parent = None):
        super(BottomWidget,self).__init__(parent)
        self.parent = parent
        self.setGeometry(0, 60, 550, 260)
        self.setWindowFlags(Qt.FramelessWindowHint)
        self.init_ui()
        self.init_style_sheet()
        self.init_connect()

    #
    # 函数：连接信号槽
    #
    def init_connect(self):
        self.layout_h_cb.cb.stateChanged.connect(self.slot_h_select)
        self.layout_all_cb.cb.stateChanged.connect(self.slot_all_select)

    #
    # 函数：初始化ui
    #
    def init_ui(self):
        self.setAutoFillBackground(True)
        palette = QPalette()
        palette.setColor(QPalette.Background, QColor(255,255,255))
        self.setPalette(palette)

        self.layout_h_cb = allselectwidget(self.width(),37,_("totality "),"",_(" entries"),False,self)
        self.layout_h_cb.setFixedSize(550,37)
        self.layout_h_cb.setGeometry(0,0,550,35)
        self.layout_h_cb.show()

        self.sp_selection = QListWidget(self)
        self.sp_selection.setFrameShape(QFrame.NoFrame)
        self.sp_selection.setFocusPolicy(Qt.NoFocus)
        self.sp_selection.setSpacing(0)
        self.sp_selection.setFixedSize(550, 155)
        self.sp_selection.move(0, 36)
        self.sp_selection.hide()

        self.lw_all_selection = QListWidget(self)
        self.lw_all_selection.setFrameShape(QFrame.NoFrame)
        self.lw_all_selection.setFocusPolicy(Qt.NoFocus)
        self.lw_all_selection.setSpacing(0)
        self.lw_all_selection.setFixedSize(550, 455)
        self.lw_all_selection.move(0,36)
        self.lw_all_selection.hide()

        self.splitlabel = QLabel(self)
        self.splitlabel.setStyleSheet("QLabel{background-color:#cfcfcf;border:0px solid #cfcfcf;}")
        self.splitlabel.setGeometry(0,491,self.width(),1)

        self.layout_all_cb = allselectwidget(self.width(),70,_("All selection"),"","",True,self)
        #self.layout_all_cb.setAttribute(Qt.WA_TranslucentBackground)
        self.layout_all_cb.setFixedSize(550,70)
        self.layout_all_cb.setGeometry(0,self.height()-70,550,70)

        self.layout_all_cb.show()

    #
    # 函数：初始化样式
    #
    def init_style_sheet(self):
        self.lw_all_selection.setStyleSheet("QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:70px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background:#F4F4F4;}QListWidget::item:selected{background:#F4F4F4;}")
        self.lw_all_selection.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                 QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                 QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                 QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                 QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                 QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")
        self.sp_selection.setStyleSheet("QListWidget{background-color:white;border:0px solid #cfcfcf;}QListWidget::item{background-color:white;height:80px;margin-top:0px;border:0px solid #cfcfcf;}QListWidget::item:hover{background:#F4F4F4;}QListWidget::item:selected{background:#F4F4F4;}")
        self.sp_selection.verticalScrollBar().setStyleSheet("QScrollBar:vertical{margin:0px 0px 0px 0px;background-color:rgb(255,255,255,100);border:0px;width:6px;}\
                                                                 QScrollBar::sub-line:vertical{subcontrol-origin:margin;border:0px solid red;height:13px}\
                                                                 QScrollBar::up-arrow:vertical{subcontrol-origin:margin;background-color:rgba(0,0,0,0);height:13px}\
                                                                 QScrollBar::sub-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::handle:vertical{background-color:rgba(0,0,0,20%);width:6px;border-radius:6px;} QScrollBar::handle:vertical:hover{background-color:rgb(0,0,0,10%);opacity:0.1;width:6px;border-radius:6px;}  QScrollBar::handle:vertical:pressed{background-color:rgb(0,0,0,50%);width:6px;border-radius:6px;}\
                                                                 QScrollBar::add-page:vertical{background-color:#EEEDF0;}\
                                                                 QScrollBar::down-arrow:vertical{background-color:rgba(0,0,0,0);}\
                                                                 QScrollBar::add-line:vertical{subcontrol-origin:margin;border:0px solid green;height:13px}")

    #
    # 函数：显示多种升级列表
    #
    def show_both_title(self):
        self.layout_h_cb.show()
        #self.label_all_select.show()
        self.layout_all_cb.show()

    #
    # 函数：设置立即更新按钮的样式
    #
    def set_update_sytylesheet(self, state):
        if self.lw_all_selection.count() == 0:
            state = 0
        if state == 0:
            self.layout_all_cb.button_update.setStyleSheet(
                "QPushButton{border-radius:4px;background-color:#e9e9e9;color:#c1c1c1;font-size:16px;}")
        elif state == 2:
            self.layout_all_cb.button_update.setStyleSheet(
                "QPushButton{border-radius:4px;background-color:#3d6be5;color:#ffffff;font-size:16px;}"
                "QPushButton:hover{border-radius:4px;background-color:#6b8eeb;color:#ffffff;font-size:16px;}"
                "QPushButton:pressed{border-radius:4px;background-color:#4e5fc4;color:#ffffff;font-size:16px;}")

    #
    # 函数：设置全选
    #
    def slot_h_select(self,state):
        if self.lw_all_selection.count() == 0:
            state = 0
        if state == 2:
            self.layout_h_cb.cb.setCheckState(2)
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                itemWidget.checkBox.setCheckState(2)
        elif state == 0:
            self.layout_h_cb.cb.setCheckState(0)
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                if itemWidget.is_working == False:
                    itemWidget.checkBox.setCheckState(0)
        self.set_update_sytylesheet(state)

    #
    # 函数：设置全选
    #
    def slot_all_select(self, state):
        if self.lw_all_selection.count() == 0:
            state = 0
        #点击全选框
        if state == 2:
            self.layout_all_cb.cb.setCheckState(2)
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                itemWidget.checkBox.setCheckState(2)
        #取消全选
        elif state == 0:
            self.layout_all_cb.cb.setCheckState(0)
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                itemWidget.checkBox.setCheckState(0)
        self.set_update_sytylesheet(state)

    #
    # 函数：检查是否是否全选或全部取消
    #
    def check_important_status(self, status):
        if status:
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                if itemWidget.checkBox.isChecked() == False:
                    self.layout_h_cb.cb.setTristate(True)
                    self.layout_h_cb.cb.setCheckState(1)
                    self.layout_all_cb.cb.setCheckState(1)
                    self.set_update_sytylesheet(2)
                    return
            self.layout_h_cb.cb.setTristate(False)
            self.layout_all_cb.cb.setTristate(False)
            self.layout_h_cb.cb.setCheckState(2)
            self.layout_all_cb.cb.setCheckState(2)
        else:
            for i in range(self.lw_all_selection.count()):
                item = self.lw_all_selection.item(i)
                itemWidget = self.lw_all_selection.itemWidget(item)
                if itemWidget.checkBox.isChecked() == True:
                    self.layout_h_cb.cb.setCheckState(1)
                    self.layout_all_cb.cb.setCheckState(1)
                    self.set_update_sytylesheet(2)
                    return
            self.layout_h_cb.cb.setTristate(False)
            self.layout_all_cb.cb.setTristate(False)
            self.layout_h_cb.cb.setCheckState(0)
            self.layout_all_cb.cb.setCheckState(0)
            self.set_update_sytylesheet(0)
