#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sqlite3
import datetime
import gettext
import shutil
from utils.enums import HOMECACHE, DB_FILE, DB_MODEL_PATH

gettext.textdomain("kylin-update-manager")

_ = gettext.gettext

#
#类：数据库存放安装信息，安装时间、安装版本以及安装的名字
#
class install_information:

    version = ""
    appname = ""
    time = ""
    description = ""
    icon = ""

    def __init__(self):
        if os.path.isfile(DB_FILE):
            self.connect = sqlite3.connect(DB_FILE, check_same_thread=False)
            self.cursor = self.connect.cursor()
        else:
            #不存在拷贝模板文件到cache,并判断目录是否存在，用户可能自己删除掉
            if os.path.isdir(HOMECACHE):
                pass
            else:
                os.system("mkdir " + HOMECACHE)
            shutil.copy(DB_MODEL_PATH, HOMECACHE)
            self.connect = sqlite3.connect(DB_FILE, check_same_thread=False)
            # self.cursor = self.connect.cursor()
            # self.cursor.execute('''create table installed(appname text,version  text,time text,description text,icon blob,statue text,keyword text)''')
            # self.connect.commit()
            # self.cursor.close()
            # self.connect.close()
            # self.connect = sqlite3.connect(DB_FILE, check_same_thread=False)
            self.cursor = self.connect.cursor()
            os.system("chmod 755 "+DB_FILE)

    #
    #函数:将软件的安装信息写入数据库
    #
    def insert(self,app_name,version,description,icon,statue,keyword = ""):
        time = datetime.datetime.now()
        timestr = datetime.datetime.strftime(time,"%Y-%m-%d %H:%M:%S")
        try:
            self.cursor.execute("insert into installed values(?,?,?,?,?,?,?)",
                                (app_name,version,timestr,description,icon,statue,keyword))
            self.connect.commit()
            self.cursor.close()
            self.connect.close()
        except:
            shutil.copy(DB_MODEL_PATH, HOMECACHE)
            self.connect = sqlite3.connect(DB_FILE, check_same_thread=False)
            self.cursor.execute("insert into installed values(?,?,?,?,?,?,?)",
                                (app_name, version, timestr, description, icon, statue, keyword))
            self.connect.commit()
            self.cursor.close()
            self.connect.close()

    #
    # 函数:将本地软件的安装信息写入数据库
    #
    def local_insert(self, app_name, version, description, icon, statue,keyword):
        time = datetime.datetime.now()
        timestr = datetime.datetime.strftime(time, "%Y-%m-%d %H:%M:%S")
        try:
            self.cursor.execute("insert into installed values(?,?,?,?,?,?,?)",
                                (app_name, version, timestr, description, icon, statue,keyword))
            self.connect.commit()
            self.cursor.close()
            self.connect.close()
        except:
            shutil.copy(DB_MODEL_PATH, HOMECACHE)
            self.connect = sqlite3.connect(DB_FILE, check_same_thread=False)
            self.cursor.execute("insert into installed values(?,?,?,?,?,?,?)",
                                (app_name, version, timestr, description, icon, statue, keyword))
            self.connect.commit()
            self.cursor.close()
            self.connect.close()

    #
    # 函数:读取数据库的信息
    #
    def select(self):
        self.cursor.execute("select * from installed order by time desc")

    def select_order(self,text,i):
        if i == 0:
            sql = "select * from installed where keyword like '%" + text + "' or statue like '%" + text + "%' or time like '%" + text + "%' or appname like '%" + text + "%' order by time desc"
            self.cursor.execute(sql)
        else:
            sql = "select * from installed where keyword like '%" + text + "' or statue like '%" + text + "%' or time like '%" + text + "%' or appname like '%" + text + "%' order by time asc"
            self.cursor.execute(sql)

    def search_select(self,text):
        statue = text
        if (text in "更新成功") or (text in _("update seccussed")):
            statue = "Success"
        elif (text in "更新失败") or (text in _("update failed")):
            statue = "Fail"
        if (statue == "Success" or statue == "Fail"):
            sql = "select * from installed where keyword like '%" + text + "%' or time like '%" + text + "%' or appname like '%" + text + "%'or statue like '%" + statue + "%' order by time desc"
        else:
            sql = "select * from installed where keyword like '%" + text + "%' or time like '%" + text + "%' or appname like '%" + text + "%' order by time desc"
        self.cursor.execute(sql)

    def sort_by_statue_select1(self, statue,text,i):
        if (i == 1):
            sql = "select * from installed where statue='" + statue + "' and (keyword like '%" + text + "' appname like '%" + text + "%' or time like '%" + text + "%') order by time asc"
            self.cursor.execute(sql)
        else:
            sql = "select * from installed where statue='" + statue + "' and (keyword like '%" + text + "' appname like '%" + text + "%' or time like '%" + text + "%') order by time desc"
            # print(sql)
            self.cursor.execute(sql)

    #
    #函数：查询虚包
    #
    def select_package(self,appname):
        self.cursor.execute("select * from installed where appname= ? and statue='Success' order by time desc",(appname,))

    #
    # 函数:更新数据库中的信息
    #
    def update(self,appname,version):
        time = datetime.datetime.now()
        timestr = datetime.datetime.strftime(time, "%Y-%m-%d %H:%M:%S")
        self.cursor.execute("update installed time=?,version=? where appname=?",(timestr,version,appname,))
