#!/usr/bin/python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import pyqtSignal
from apt import package
import gettext
import os,re
from xdg import BaseDirectory as xdg
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

# VERSION = "v5.4.2"
results = os.popen("dpkg -l | grep kylin-update-manager").readlines()
for res in results:
    res = re.sub(" +", " ", res)
    if str(res).split(" ")[1] == "kylin-update-manager":
        VERSION = "v"+re.sub("[kord]", "", res.split(" ")[2])


INTERFACE = "cn.kylinos.KylinUpdateManager"
INTERFACES = "/cn/kylinos/KylinUpdateManager"
SINTERFACE = "cn.kylinos.KylinUpdateManager.singleton"
SINTERFACES = "/cn/kylinos/KylinUpdateManager/singleton"

SOFTWARE_PROPERTIES_SERVICE = "com.kylin.software.properties"
SOFTWARE_PROPERTIES_PATH = "/com/kylin/software/properties"
SOFTWARE_PROPERTIES_INTERFACE = "com.kylin.software.properties.interface"


AUTOSTART = "/etc/xdg/autostart/"
CRONDAILY = "/etc/cron.hourly/"
STARTCONF = os.path.join(xdg.xdg_cache_home, "kylin-update-manager/kylin-update-manager.conf")
CONF_MODEL_PATH = os.path.join("/usr/share/kylin-update-manager/kylin-update-manager.conf")
LAST_START_TIME = os.path.join("/usr/share/kylin-update-manager/last-start-time")
DOWN_CACHE_PATH = os.path.join(xdg.xdg_cache_home, "kylin-update-manager/kylin-update-manager-deb")
DOWN_TEMP_PATH = os.path.join(xdg.xdg_cache_home, "kylin-update-manager/kylin-update-manager-deb/deb")
HOMECACHE = os.path.join(xdg.xdg_cache_home, "kylin-update-manager")
DB_FILE = os.path.join(xdg.xdg_cache_home, "kylin-update-manager/kylin-update-manager.db")
DB_MODEL_PATH = os.path.join("/usr/share/kylin-update-manager/kylin-update-manager.db")
IMPORTANT_PATH = "/var/lib/kylin-software-properties/template/important.list"
CRUCIAL_PATH = "/var/lib/kylin-software-properties/template/crucial.list"

BUTTON_LEAVE = 0
BUTTON_ENTER = 1
BUTTON_PRESSED = 2
BUTTON_DISABLE = 3

LOADINGWIDTH = 570
LOADINGHEIGHT = 340
SPWIDTH=550
SPHEIGHT=320
MAINWIDTH = 570
MAINHEIGHT = 640
DETAILWIDTH = 336
DETAILHEIGHT = 378
RUNLIST = []

iname_list = []
cname_list = []


class LaunchMode:
    AUTOMATIC = "launch_mode_automatic"
    MANUAL = "launch_mode_manual"

class TaskMode:
    UPDATEKUM = "task_mode_updatekum"
    UPDATEOS = "task_mode_updateos"
    UPDATEPKG = "task_mode_updatepkg"

class LWMode:
    ORDINARY = "ordinary"
    IMPORTANT = "important"
    BOTH = "both"
    SP = "sp"

# 检测到的可用的升级媒介类型
class AUPSource:
    NOSOURCE = "no_source"
    DVDSOURCE = "dvd_source"
    FTPSOURCE = "ftp_source"
    HTTPSOURCE = "http_source"

class AppType:
    ORDINARY = "ordinary"
    IMPORTANT = "important"
    CRUCIAL = "crucial"
    SP = "sp"

class AptFunc:
    INIT = "init"
    GET_KYLIN_UPDATE = "get_kylin_update"
    GET_ALL_UPDATE = "get_all_update"

class Signals:
    update_source_cancel = pyqtSignal(name="update_source_cancel")
    dbus_process_msg = pyqtSignal(str, str, str, float, str, str)
    get_kylin_update_over = pyqtSignal(list, package.Package)
    check_os_update_over = pyqtSignal(bool, bool)
    start_tray_msg = pyqtSignal(name="check_os_update_over")
    def __init__(self):
        pass

class AppActions:
    INSTALLDEPS = "install_deps"
    INSTALLDEBFILE = "install_debfile"
    INSTALL = "install"
    REMOVE = "remove"
    UPGRADE = "upgrade"
    CANCEL = "cancel"
    APPLY = "apply_changes"
    PURCHASE = "purchase"
    UPDATE = "update"
    UPDATE_FIRST = "update_first"
    ADD_SOURCE = "add_source"
    REMOVE_SOURCE = "remove_source"
    GET_SOURCES = "get_sources"

#AptActionMsg = {
#    "install": "安装",
#    "upgrade": "更新",
#    "update": "源更新",
#}
AptActionMsg = {
    "install": _("install"),
    "upgrade": _("upgrade"),
    "update": _("update"),
}

#AptProcessMsg = {
#    "apt_start": "开始...",
#    "apt_finish": "完成!",
#    "apt_error": "失败!",
#    "apt_pulse": "进行中",
#    "down_start": "下载开始",
#    "down_stop": "下载完成",
#    "down_done": "下载",
#    "down_fail": "下载失败",
#    "down_fetch": "单项下载完成",
#    "down_pulse": "下载进行中...",
#    "down_cancel": "下载取消",
#}

AptProcessMsg = {
    "apt_start": _("start..."),
    "apt_finish": _("finish!"),
    "apt_error": _("failed!"),
    "apt_pulse": _("running"),
    "down_start": _("download start"),
    "down_stop": _("download complete"),
    "down_done": _("download"),
    "down_fail": _("download failed"),
    "down_fetch": _("download single entry complete"),
    "down_pulse": _("downloading..."),
    "down_cancel": _("download cancel"),
}

class AppMsg:
    ZH_CN_NAME = ""
    NAME = ""
    ICON = ""
    SIZE = ""
    BYTESIZE = 0
    INSTALLEDVERSION = ""
    CANDIDATEVERSION = ""
    DESCRIPTION = ""
    STATUE = ""
    TIME = ""
    ARCHITECTURE = ""
    FULLVERSION = ""
    TYPE = ""
